# https://github.com/sintegrial/qwtplot3d/commit/e30f5df877c783a5ca1737ac219d8dd79d03d2ff
%global commit0 e30f5df877c783a5ca1737ac219d8dd79d03d2ff
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})
%global commitdate 20170630

%global soname 0.3.1

Name:           qwtplot3d-qt5
Version:        0.3.1a
Release:        3.%{commitdate}git%{shortcommit0}%{?dist}
Summary:        Extended version of the original QwtPlot3D library
# zlib/libpng License
License:        zlib
URL:            https://github.com/sintegrial/qwtplot3d
Source0:        https://github.com/sintegrial/qwtplot3d/archive/%{commit0}.zip#/qwtplot3d-%{commit0}.zip

## Fix compiler paths and cxx flags
Patch0:  %{name}-includedir.patch

Requires:       pkgconfig(Qt5Core)
BuildRequires:  pkgconfig(glu)
BuildRequires:  pkgconfig(xmu)
Buildrequires:  qt5-rpm-macros, qt5-qtbase-devel
BuildRequires:  gl2ps-devel
BuildRequires:  gcc-c++

%description
QwtPlot3D is not a program, but a feature-rich Qt/OpenGL-based C++
programming library, providing essentially a bunch of 3D-widgets for
programmers.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains qt5 libraries and header files for
developing applications that use %{name}.

%prep
%setup -qc -n qwtplot3d-%{commit0}

mv qwtplot3d-%{commit0} qt5
pushd qt5
%patch0 -p0
# enable shared build
sed -i -e 's|qt warn_on thread static|qt warn_on thread shared|' config.pri
sed -i -e 's|qt warn_on thread static|qt warn_on thread shared|' src/src.pro
popd

%build
############### QT5 ######################
pushd qt5
mkdir -p build && cd build
# treating soname
sed -i -e 's|TARGET            = qwtplot3d|TARGET            = qwtplot3d-qt5|' ../src/src.pro
sed -i -e 's|-lqwtplot3d|-lqwtplot3d-qt5|' ../examples/common.pro

%{_qt5_qmake} ../qwtplot3d.pro \
 QMAKE_CXXFLAGS="%{optflags}" \
 QMAKE_CFLAGS="%{optflags}" \
 QMAKE_LFLAGS="%{__global_ldflags} -L%{_libdir} -lGLU"
%make_build
cd ..
popd

%install

############### QT5 ######################
pushd qt5
mkdir -p %{buildroot}%{_qt5_headerdir}/%{name}
install -p -m 0644 include/* %{buildroot}%{_qt5_headerdir}/%{name}

mkdir -p %{buildroot}%{_qt5_libdir}
install -p -m 0755 build/lib/lib%{name}.* %{buildroot}%{_qt5_libdir}/
ln -sf lib%{name}.so.%{soname} %{buildroot}%{_qt5_libdir}/lib%{name}.so
ln -sf lib%{name}.so.%{soname} %{buildroot}%{_qt5_libdir}/lib%{name}.so.0
ln -sf lib%{name}.so.%{soname} %{buildroot}%{_qt5_libdir}/lib%{name}.so.0.3

mkdir -p %{buildroot}%{_libexecdir}/%{name}
install -pm 755 build/examples/bin/* %{buildroot}%{_libexecdir}/%{name}/

%ldconfig_scriptlets

%files
%license qt5/license.txt
%doc qt5/readme.txt
%{_qt5_libdir}/lib%{name}.so.*

%files devel
%{_libexecdir}/%{name}/
%{_qt5_headerdir}/%{name}/
%{_qt5_libdir}/lib%{name}.so

%changelog
* Sat Feb 17 2018 Antonio Trande <sagitter@fedoraproject.org> - 0.3.1a-3.20170630gite30f5df
- Use %%ldconfig_scriptlets

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.1a-2.20170630gite30f5df
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Nov 12 2017 Antonio Trande <sagitter@fedoraproject.org> - 0.3.1a-1.20170630gite30f5df
- Update to 0.3.1 (pre-release)
- Build QT5 library
